/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *
 */

package org.teiid.translator.jdbc;

import org.teiid.language.ColumnReference;
import org.teiid.language.Expression;
import org.teiid.language.Function;

import java.util.ArrayList;
import java.util.List;

/**
 * Alias Modifier ensures functions receiving dataTypes not supported (such as UUID in trino)
 * will rebuild the query while casting the column parameters and applying the alias if exists
 *
 * @author Matias Szaingurten
 * @date 2024.02.22
 *
 */
public class StringAliasFunctionModifier extends AliasModifier {

    /**
     * Constructor that takes the alias to use for functions.
     *
     * @param alias The alias to replace the incoming function name with
     */
    public StringAliasFunctionModifier() {
        this(null);
    }

    public StringAliasFunctionModifier(String alias) {
        super(alias);
    }

    @Override
    public List<?> translate(Function function) {
        List<Object> objs = new ArrayList<>();
        List<Expression> parameters = function.getParameters();
        objs.add(alias != null ? alias : function.getName());
        objs.add("(");
        for (Expression parameter : parameters) {
            addCastToVarchar(parameter, objs);
            objs.add(", ");
        }
        objs.remove(objs.size() - 1);
        objs.add(")");
        return objs;
    }

    private void addCastToVarchar(Expression expression, List<Object> objs) {
        if (expression instanceof ColumnReference) {
            objs.add("CAST(" + expression + " AS VARCHAR)");
            return ;
        }
        if (expression != null) {
            objs.add(expression);
        }
    }

}
